summaryrefslogtreecommitdiffstats
path: root/yardstick
diff options
context:
space:
mode:
authorhoujingwen <houjingwen@huawei.com>2015-07-03 07:58:25 +0000
committerhoujingwen <houjingwen@huawei.com>2015-07-06 02:40:51 +0000
commit6b667910909b332e78105ccdf17e39e4b286ed39 (patch)
treeb58a13ad4f8b65dda0e289012c89a7410bd30271 /yardstick
parentbca83ab90d5f6ffb0afe5f2e756e3fd37f85c2a7 (diff)
Add support for measuring storage performance use fio
A simple test case is added that will test writes to ephemeral storage. See samples/fio.yaml The Fio test type can also be used to test block storage, just modify the "filename" argument. JIRA: YARDSTICK-34 Change-Id: I1758d2999f8a5fdd44726e1dfc3e9769ea39dad6 Signed-off-by: houjingwen <houjingwen@huawei.com>
Diffstat (limited to 'yardstick')
-rw-r--r--yardstick/benchmark/scenarios/storage/__init__.py0
-rw-r--r--yardstick/benchmark/scenarios/storage/fio.py139
-rw-r--r--yardstick/benchmark/scenarios/storage/fio_benchmark.bash81
3 files changed, 220 insertions, 0 deletions
diff --git a/yardstick/benchmark/scenarios/storage/__init__.py b/yardstick/benchmark/scenarios/storage/__init__.py
new file mode 100644
index 000000000..e69de29bb
--- /dev/null
+++ b/yardstick/benchmark/scenarios/storage/__init__.py
diff --git a/yardstick/benchmark/scenarios/storage/fio.py b/yardstick/benchmark/scenarios/storage/fio.py
new file mode 100644
index 000000000..a39af06aa
--- /dev/null
+++ b/yardstick/benchmark/scenarios/storage/fio.py
@@ -0,0 +1,139 @@
+##############################################################################
+# Copyright (c) 2015 Huawei Technologies Co.,Ltd.
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+import pkg_resources
+import logging
+import json
+
+import yardstick.ssh as ssh
+from yardstick.benchmark.scenarios import base
+
+LOG = logging.getLogger(__name__)
+LOG.setLevel(logging.DEBUG)
+
+
+class Fio(base.Scenario):
+ """Execute fio benchmark on host
+
+ Parameters
+ filename - file name for fio workload
+ type: string
+ unit: na
+ default: /home/ec2-user/data.raw
+ bs - block size used for the io units
+ type: int
+ unit: bytes
+ default: 4k
+ rw - type of io pattern [read, write, randwrite, randread, rw, randrw]
+ type: string
+ unit: na
+ default: write
+ ramp_time - run time before logging any performance
+ type: int
+ unit: seconds
+ default: 20
+
+ Read link below for more fio args description:
+ http://www.bluestop.org/fio/HOWTO.txt
+ """
+ __scenario_type__ = "Fio"
+
+ TARGET_SCRIPT = "fio_benchmark.bash"
+
+ def __init__(self, context):
+ self.context = context
+ self.setup_done = False
+
+ def setup(self):
+ '''scenario setup'''
+ self.target_script = pkg_resources.resource_filename(
+ "yardstick.benchmark.scenarios.storage",
+ Fio.TARGET_SCRIPT)
+ user = self.context.get("user", "root")
+ host = self.context.get("host", None)
+ key_filename = self.context.get("key_filename", "~/.ssh/id_rsa")
+
+ LOG.debug("user:%s, host:%s", user, host)
+ self.client = ssh.SSH(user, host, key_filename=key_filename)
+ self.client.wait(timeout=600)
+
+ # copy script to host
+ self.client.run("cat > ~/fio.sh",
+ stdin=open(self.target_script, "rb"))
+
+ self.setup_done = True
+
+ def run(self, args):
+ """execute the benchmark"""
+ default_args = "-ioengine=libaio -direct=1 " \
+ "-group_reporting -numjobs=1 -time_based"
+
+ if not self.setup_done:
+ self.setup()
+
+ options = args["options"]
+ filename = options.get("filename", "/home/ec2-user/data.raw")
+ bs = options.get("bs", "4k")
+ rw = options.get("rw", "write")
+ ramp_time = options.get("ramp_time", 20)
+ name = "yardstick-fio"
+ # if run by a duration runner
+ duration_time = self.context.get("duration", None)
+ # if run by an arithmetic runner
+ arithmetic_time = options.get("duration", None)
+ if duration_time:
+ runtime = duration_time
+ elif arithmetic_time:
+ runtime = arithmetic_time
+ else:
+ runtime = 30
+
+ args = "-filename=%s -bs=%s -rw=%s -ramp_time=%s -runtime=%s -name=%s" \
+ % (filename, bs, rw, ramp_time, runtime, name)
+ cmd = "sudo bash fio.sh %s %s %s" \
+ % (filename, args, default_args)
+ LOG.debug("Executing command: %s", cmd)
+ status, stdout, stderr = self.client.execute(cmd)
+ if status:
+ raise RuntimeError(stderr)
+
+ data = json.loads(stdout)
+
+ # TODO: add sla check
+
+ return data
+
+
+def _test():
+ '''internal test function'''
+ key_filename = pkg_resources.resource_filename("yardstick.resources",
+ "files/yardstick_key")
+ ctx = {
+ "host": "10.0.0.101",
+ "user": "ec2-user",
+ "key_filename": key_filename
+ }
+
+ logger = logging.getLogger("yardstick")
+ logger.setLevel(logging.DEBUG)
+
+ fio = Fio(ctx)
+
+ options = {
+ "filename": "/home/ec2-user/data.raw",
+ "bs": "4k",
+ "rw": "write",
+ "ramp_time": 10,
+ }
+ args = {"options": options}
+
+ result = fio.run(args)
+ print result
+
+if __name__ == '__main__':
+ _test()
diff --git a/yardstick/benchmark/scenarios/storage/fio_benchmark.bash b/yardstick/benchmark/scenarios/storage/fio_benchmark.bash
new file mode 100644
index 000000000..0fa319dd4
--- /dev/null
+++ b/yardstick/benchmark/scenarios/storage/fio_benchmark.bash
@@ -0,0 +1,81 @@
+#!/bin/sh
+
+##############################################################################
+# Copyright (c) 2015 Huawei Technologies Co.,Ltd.
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+
+set -e
+
+# Commandline arguments
+FIO_FILENAME=$1
+shift
+OPTIONS="$@"
+OUTPUT_FILE="yardstick-fio.log"
+
+# setup data file for fio
+setup()
+{
+ if [ ! -f $FIO_FILENAME ]; then
+ dd if=/dev/zero of=$FIO_FILENAME bs=1M count=1024 oflag=direct > /dev/null 2>&1
+ fi
+}
+
+# run fio test
+run_test()
+{
+ fio $OPTIONS --output=$OUTPUT_FILE
+}
+
+# write the result to stdout in json format
+output_json()
+{
+ read_bw=$(grep "READ.*aggrb" $OUTPUT_FILE | awk -F [=\ ,] '{printf $9}')
+ write_bw=$(grep "WRITE.*aggrb" $OUTPUT_FILE | awk -F [=\ ,] '{printf $8}')
+ eval $(grep -e '\ lat.*stdev' -e "read.*iops" -e "write.*iops" -e "trim.*iops" $OUTPUT_FILE | sed 'N;s/\n/ /g' | grep read | awk -F [=\ ,\(\)] '{printf("read_iops=%s; read_lat_unit=%s; read_lat=%s", $12, $24, $33)}')
+ eval $(grep -e '\ lat.*stdev' -e "read.*iops" -e "write.*iops" -e "trim.*iops" $OUTPUT_FILE | sed 'N;s/\n/ /g' | grep write | awk -F [=\ ,\(\)] '{printf("write_iops=%s; write_lat_unit=%s; write_lat=%s", $11, $23, $32)}')
+
+ read_bw=${read_bw:-N/A}
+ write_bw=${write_bw:-N/A}
+ read_iops=${read_iops:-N/A}
+ write_iops=${write_iops:-N/A}
+ if [ "x$read_lat" = "x" ]; then
+ read_lat="N/A"
+ else
+ read_lat=$read_lat$read_lat_unit
+ fi
+ if [ "x$write_lat" = "x" ]; then
+ write_lat="N/A"
+ else
+ write_lat=$write_lat$write_lat_unit
+ fi
+
+ echo -e "{ \
+ \"read_bw\":\"$read_bw\", \
+ \"write_bw\":\"$write_bw\", \
+ \"read_iops\":\"$read_iops\", \
+ \"write_iops\":\"$write_iops\", \
+ \"read_lat\":\"$read_lat\", \
+ \"write_lat\":\"$write_lat\" \
+ }"
+}
+
+# main entry
+main()
+{
+ # setup the test
+ setup
+
+ # run the test
+ run_test >/dev/null
+
+ # output result
+ output_json
+}
+
+main
+